package maze.searchers;

import static org.junit.Assert.*;

import java.util.function.Supplier;

public class QueueTest {

	public static final int NUM_ITEMS = 100;

	public static void testFIFO(Supplier<Queue<Integer>> maker) {
		Queue<Integer> queue = maker.get();
		for (int i = 0; i < NUM_ITEMS; i++) {
			queue.enqueue(i);
			assertEquals(new Integer(0), queue.peek());
		}

		for (int i = 0; i < NUM_ITEMS; i++) {
			assertEquals(new Integer(i), queue.dequeue());
			if (i < NUM_ITEMS - 1) {
				assertEquals(new Integer(i+1), queue.peek());
			} else {
				assertEquals(0, queue.size());
			}
		}
	}
}
