package maze.searchers;

import static org.junit.Assert.*;

import java.util.function.Supplier;

public class StackTest {
	
	public static final int NUM_ITEMS = 100;

	public static void testLIFO(Supplier<Stack<Integer>> maker) {
		Stack<Integer> stack = maker.get();
		for (int i = 0; i < NUM_ITEMS; i++) {
			stack.push(i);
			assertEquals(new Integer(i), stack.peek());
		}
		
		for (int i = NUM_ITEMS - 1; i >= 0; i--) {
			assertEquals(new Integer(i), stack.pop());
			if (i > 0) {
				assertEquals(new Integer(i - 1), stack.peek());
			} else {
				assertEquals(0, stack.size());
			}
		}
	}
}
